/**
 * @file rain_effect.h
 */

#ifndef _RAIN_EFFECT
#define _RAIN_EFFECT

#include "vector.h"
#include "particle_system.h"
//#include "material.h"

class SparkParticles;
class ParticleEmitter;

#include "weather_effect.h"


class RainEffect : public WeatherEffect
{
  public:
    RainEffect(const TiXmlElement* root = NULL);
    virtual ~RainEffect();

    virtual void loadParams(const TiXmlElement* root);

    virtual bool init();

    virtual bool activate();
    virtual bool deactivate();

    virtual void draw() const;

//     inline void setRainMode(const std::string& mode) { this->rainMode = this->stringToRainMode(mode); }
//     inline void setRainDensity(float density) { this->rainDensity = density; }
//     inline void setRainRange(float start, float end) { this->rainStart = start; this->rainEnd = end; }
//     inline void setRainColor(float r, float g, float b) { this->colorVector = Vector(r, g, b); }

  private:
    static SparkParticles*            rainParticles;
    ParticleEmitter*                  emitter;

//     GLfloat                 rainDensity;
//     GLfloat                 rainStart;
//     GLfloat                 rainEnd;
//     Vector                  colorVector;
};


#endif  /* _RAIN_EFFECT */
